;; Load essentials.
(load "~/.emacs.d/essential.el")

;; Packages.
(load "~/.emacs.d/packages.el")

;; Correct bad defaults.
(load "~/.emacs.d/tweaks.el")

;; Additional functions, keybinds.
(load "~/.emacs.d/custom.el")

;; Start an emacs server from this session, if it isn't already running.
;; This is useful for stuff like Nyxt where we can launch and emacsclient to
;; evaluate forms.
(when (not (server-running-p))
  (server-start))

;; Tab width.
(setq-default tab-width 4)
;; Use spaces by default.
(setq-default indent-tabs-mode nil)

;;; Appearance
;; The font is set in fontconfig. Usually it's UW Ttyp0 or Gohufont
(set-frame-font "monospace 12")
(setq default-frame-alist '((font . "monospace 12")))

;; Highlight matching parentheses.
(show-paren-mode t)

;; Mode line
(line-number-mode t)
(column-number-mode t)
(setq display-time-24hr-format t)
(display-time-mode t)

;; Electric pair mode
(setq electric-pair-pairs '((?\( . ?\))
                            (?\[ . ?\])
                            (?\{ . ?\})
                            (?\" . ?\")))
(electric-pair-mode t)

(setq-default rmail-display-summary t)

(setq
 send-mail-function 'smtpmail-send-it
 rmail-preserve-inbox      1
 rmail-delete-after-output 1
 rmail-mail-new-frame      1
 rmail-mime-prefer-html nil
 rmail-file-name    "~/mail/inbox"
 rmail-primary-inbox-list '("~/mail/inboxes/disroot")
 rmail-default-file "~/mbox/archive"
 rmail-secondary-file-directory "~/mail"
 message-default-headers "Fcc: ~/mail/sent"
 user-full-name    "opfez"
 user-mail-address "opfez@disroot.org"
 message-signature "")

;; C configuration
(setq c-default-style "linux"
      c-basic-offset 4)

;; Scheme configuration
;; (setq geiser-guile-binary "/usr/bin/guile")
;; for ncurses development, uncomment this:
;; (setq geiser-guile-binary "/usr/local/bin/guile-ncurses-shell")

(setq geiser-active-implementations '(chez))
(setq geiser-chez-binary "/usr/bin/scheme")

;; I use emacs as my window manager.
;; (exwm-config)
